#!/bin/bash

read -p "Base directory for installation [/opt/pbdc/]:" install_base
read -p "Bacula User ID [bacula]:" user_id

if [ "x$install_base" == "x" ]
then
	install_base="/opt/pbdc"
fi

if [ "x$user_id" == "x" ]
then
	user_id="bacula"
fi

mkdir -p $install_base/bin
mkdir -p $install_base/lib
mkdir -p $install_base/db

export install_base user_id

rm -f /etc/pbdc.conf
cat >> /etc/pbdc.conf << EOF
BASE_DIR=$install_base
BASE_LIB=$install_base/lib/
BASE_DATA=$install_base/db/
BACULA_USER="$user_id"

export BACULA_USER BASE_DATA BASE_LIB BASE_DIR
EOF

cp -rp bin/* $install_base/bin
cp -rp lib/* $install_base/lib
chown -R $user_id $install_base
chmod 755 $install_base/bin/*